package exercise;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayDeque;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.Vector;
import org.jgrapht.Graph;
import org.jgrapht.graph.DefaultDirectedGraph;
import org.jgrapht.graph.DefaultEdge;
import org.jgrapht.io.DOTExporter;
import org.jgrapht.io.IntegerComponentNameProvider;
import org.jgrapht.io.StringComponentNameProvider;

public class Exercise9 {

  /** Visits all nodes reachable from <code>node</code> that have not yet been
   * included in <code>visited</code> in depth first exploration order, adds
   * them to <code>visited</code> and (suitably) collects them in
   * <code>reversedPostOrder</code>.
   */
  private static void depthFirstExploration(Graph<Integer, DefaultEdge> graph,
      Integer node, HashSet<Integer> visited, ArrayDeque<Integer> reversedPostOrder) {

    // TODO exercise 3.2
  
  }

  private static ArrayDeque<Integer> getReversedPostorder(Graph<Integer, DefaultEdge> graph) {
    ArrayDeque<Integer> order = new ArrayDeque<Integer>();

    // TODO exercise 3.2

    
    return order;
  }

  private static Graph<Integer, DefaultEdge>
      getGraphWithReversedEdges(Graph<Integer, DefaultEdge> graph) {
    Graph<Integer, DefaultEdge> reversedGraph =
            new DefaultDirectedGraph<Integer, DefaultEdge>(DefaultEdge.class);

    // TODO exercise 3.1


    return reversedGraph;
  }

  /**
   *  Determines all strongly connected components of a directed graph using
   *  Kusaraju's algorithm.
   *  Every component is represented as a set of nodes (in this case Integers)
   *  and the list of all such components returned (without any particular
   *  order).
   */
  public static List<Set<Integer>> getStronglyConnectedComponents(Graph<Integer,
      DefaultEdge> graph) {
    List<Set<Integer>> stronglyConnectedComponents = new Vector<Set<Integer>>();

    // TODO exercise 3.3
    
    return stronglyConnectedComponents;
  }

  private static void writeGraph(Graph<Integer, DefaultEdge> graph, String
      targetDirectory, String fileName) {
    DOTExporter<Integer,DefaultEdge> exporter = new DOTExporter<Integer,DefaultEdge>(
        new IntegerComponentNameProvider<Integer>(),
        new StringComponentNameProvider<Integer>(), null);

    new File(targetDirectory).mkdirs();
    try {
      exporter.exportGraph(graph, new FileWriter(targetDirectory + fileName));
    } catch (IOException e) {
      System.err.println("Error: could not write to " + targetDirectory + fileName);
      System.err.println(e);
    }
  }

  /** 
   *  The method runs Kosaraju's algorithm for identifying all strongly
   *  connected components on an example directed graph.
   */
  public static void main(String[] args) {
    Graph<Integer, DefaultEdge> directedGraph =
            new DefaultDirectedGraph<Integer, DefaultEdge>(DefaultEdge.class);
    for (int i = 0; i < 8; i++) {
      directedGraph.addVertex(i);
    }
    directedGraph.addEdge(0, 1);
    directedGraph.addEdge(1, 3);
    directedGraph.addEdge(3, 3);
    directedGraph.addEdge(3, 0);
    directedGraph.addEdge(4, 3);
    directedGraph.addEdge(4, 5);
    directedGraph.addEdge(5, 6);
    directedGraph.addEdge(6, 4);
    directedGraph.addEdge(7, 5);
    directedGraph.addEdge(7, 6);

    //System.out.println(directedGraph.toString());
    //writeGraph(directedGraph, "graphs/", "testGraph.dot");

    List<Set<Integer>> sccs = getStronglyConnectedComponents(directedGraph);
    System.out.println(sccs);
  }

}
